searchNodes=[{"doc":"Exile is an alternative for beam ports with back-pressure and non-blocking IO","ref":"Exile.html","title":"Exile","type":"module"},{"doc":"Runs the given command with arguments and return an Enumerable to read command output. First parameter must be a list containing command with arguments. example: [&quot;cat&quot;, &quot;file.txt&quot;] . Options input - Input can be either an Enumerable or a function which accepts Collectable . Enumerable: # List Exile . stream! ( ~w(base64) , input : [ &quot;hello&quot; , &quot;world&quot; ] ) |&gt; Enum . to_list ( ) # Stream Exile . stream! ( ~w(cat) , input : File . stream! ( &quot;log.txt&quot; , [ ] , 65536 ) ) |&gt; Enum . to_list ( ) Collectable: If the input in a function with arity 1, Exile will call that function with a Collectable as the argument. The function must push input to this collectable. Return value of the function is ignored. Exile . stream! ( ~w(cat) , input : fn sink -&gt; Enum . into ( 1 .. 100 , sink , &amp; to_string / 1 ) end ) |&gt; Enum . to_list ( ) By defaults no input will be given to the command exit_timeout - Duration to wait for external program to exit after completion before raising an error. Defaults to :infinity max_chunk_size - Maximum size of each iodata chunk emitted by stream. Chunk size will be variable depending on the amount of data availble at that time. Defaults to 65535 use_stderr - When set to true, stream will contain stderr output along with stdout output. Element of the stream will be of the form {:stdout, iodata} or {:stderr, iodata} to differentiate different streams. Defaults to false. See example below All other options are passed to Exile.Process.start_link/2 Examples Exile . stream! ( ~w(ffmpeg -i pipe:0 -f mp3 pipe:1) , input : File . stream! ( &quot;music_video.mkv&quot; , [ ] , 65535 ) ) |&gt; Stream . into ( File . stream! ( &quot;music.mp3&quot; ) ) |&gt; Stream . run ( ) Stream with stderr Exile . stream! ( ~w(ffmpeg -i pipe:0 -f mp3 pipe:1) , input : File . stream! ( &quot;music_video.mkv&quot; , [ ] , 65535 ) , use_stderr : true ) |&gt; Stream . transform ( fn -&gt; File . open! ( &quot;music.mp3&quot; , [ :write , :binary ] ) end , fn elem , file -&gt; case elem do { :stdout , data } -&gt; :ok = IO . binwrite ( file , data ) { :stderr , msg } -&gt; :ok = IO . write ( msg ) end { [ ] , file } end , fn file -&gt; :ok = File . close ( file ) end ) |&gt; Stream . run ( )","ref":"Exile.html#stream!/2","title":"Exile.stream!/2","type":"function"},{"doc":"","ref":"Exile.html#t:collectable_func/0","title":"Exile.collectable_func/0","type":"type"},{"doc":"GenServer which wraps spawned external command. Exile.stream!/1 should be preferred over using this. Use this only if you need more control over the life-cycle of IO streams and OS process. Comparison with Port it is demand driven. User explicitly has to read the command output, and the progress of the external command is controlled using OS pipes. Exile never load more output than we can consume, so we should never experience memory issues it can close stdin while consuming output tries to handle zombie process by attempting to cleanup external process. Note that there is no middleware involved with exile so it is still possbile to endup with zombie process. selectively consume stdout and stderr streams Internally Exile uses non-blocking asynchronous system calls to interact with the external process. It does not use port's message based communication, instead uses raw stdio and NIF. Uses asynchronous system calls for IO. Most of the system calls are non-blocking, so it should not block the beam schedulers. Make use of dirty-schedulers for IO","ref":"Exile.Process.html","title":"Exile.Process","type":"module"},{"doc":"Waits for the program to terminate. If the program terminates before timeout, it returns {:ok, exit_status} else returns :timeout","ref":"Exile.Process.html#await_exit/2","title":"Exile.Process.await_exit/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Exile.Process.html#child_spec/1","title":"Exile.Process.child_spec/1","type":"function"},{"doc":"Closes external program's input stream","ref":"Exile.Process.html#close_stdin/1","title":"Exile.Process.close_stdin/1","type":"function"},{"doc":"Callback implementation for GenServer.handle_continue/2 .","ref":"Exile.Process.html#handle_continue/2","title":"Exile.Process.handle_continue/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Exile.Process.html#init/1","title":"Exile.Process.init/1","type":"function"},{"doc":"Sends signal to external program","ref":"Exile.Process.html#kill/2","title":"Exile.Process.kill/2","type":"function"},{"doc":"Returns OS pid of the command","ref":"Exile.Process.html#os_pid/1","title":"Exile.Process.os_pid/1","type":"function"},{"doc":"Returns bytes from executed command's stdout stream with maximum size max_size . Blocks if no bytes are written to stdout stream yet. And returns as soon as bytes are availble","ref":"Exile.Process.html#read/2","title":"Exile.Process.read/2","type":"function"},{"doc":"Returns bytes from either stdout or stderr stream with maximum size max_size whichever is availble. Blocks if no bytes are written to stdout/stderr stream yet. And returns as soon as bytes are availble","ref":"Exile.Process.html#read_any/2","title":"Exile.Process.read_any/2","type":"function"},{"doc":"Returns bytes from executed command's stderr stream with maximum size max_size . Blocks if no bytes are written to stdout stream yet. And returns as soon as bytes are availble","ref":"Exile.Process.html#read_stderr/2","title":"Exile.Process.read_stderr/2","type":"function"},{"doc":"Starts Exile.ProcessServer Starts external program using cmd_with_args with options opts cmd_with_args must be a list containing command with arguments. example: [&quot;cat&quot;, &quot;file.txt&quot;] . Options cd - the directory to run the command in env - a list of tuples containing environment key-value. These can be accessed in the external program use_stderr - when set to true, exile connects stderr stream for the consumption. Defaults to false. Note that when set to true stderr must be consumed to avoid external program from blocking","ref":"Exile.Process.html#start_link/2","title":"Exile.Process.start_link/2","type":"function"},{"doc":"Stops the exile process, external program will be terminated in the background","ref":"Exile.Process.html#stop/1","title":"Exile.Process.stop/1","type":"function"},{"doc":"Writes iodata data to program's input streams This blocks when the pipe is full","ref":"Exile.Process.html#write/2","title":"Exile.Process.write/2","type":"function"},{"doc":"","ref":"Exile.Process.html#t:process/0","title":"Exile.Process.process/0","type":"type"},{"doc":"Defines a Exile.Stream struct returned by Exile.stream!/2 .","ref":"Exile.Stream.html","title":"Exile.Stream","type":"module"},{"doc":"","ref":"Exile.Stream.html#t:t/0","title":"Exile.Stream.t/0","type":"type"},{"doc":"","ref":"Exile.Process.Error.html","title":"Exile.Process.Error","type":"exception"},{"doc":"Exile is an alternative to ports for running external programs. It provides back-pressure, non-blocking io, and tries to fix ports issues. Exile is built around the idea of having demand-driven, asynchronous interaction with external process. Think of streaming a video through ffmpeg to serve a web request. Exile internally uses NIF. See Rationale for details. It also provides stream abstraction for interacting with an external program. For example, getting audio out of a stream is as simple as Exile . stream! ( ~w(ffmpeg -i pipe:0 -f mp3 pipe:1) , input : File . stream! ( &quot;music_video.mkv&quot; , [ ] , 65535 ) ) |&gt; Stream . into ( File . stream! ( &quot;music.mp3&quot; ) ) |&gt; Stream . run ( ) See Exile.stream!/2 module doc for more details about handling stderr and other options. Exile.stream!/2 is a convenience wrapper around Exile.Process . Prefer using Exile.stream! over using Exile.Process directly. Exile requires OTP v22.1 and above. Exile is based on NIF, please know consequence of that before using Exile. For basic use cases use ExCmd instead.","ref":"readme.html","title":"Exile","type":"extras"},{"doc":"def deps do [ { :exile , &quot;~&gt; x.x.x&quot; } ] end","ref":"readme.html#installation","title":"Exile - Installation","type":"extras"},{"doc":"Existing approaches Port Port is the default way of executing external commands. This is okay when you have control over the external program's implementation and the interaction is minimal. Port has several important issues. it can end up creating zombie process cannot selectively close stdin. This is required when the external programs act on EOF from stdin it sends command output as a message to the beam process. This does not put back pressure on the external program and leads exhausting VM memory Middleware based solutions Libraries such as Porcelain , Erlexec , Rambo , etc. solves the first two issues associated with ports - zombie process and selectively closing STDIN. But not the third issue - having back-pressure. At a high level, these libraries solve port issues by spawning an external middleware program which in turn spawns the program we want to run. Internally uses port for reading the output and writing input. Note that these libraries are solving a different subset of issues and have different functionality, please check the relevant project page for details. no back-pressure additional os process (middleware) for every execution of your program in few cases such as porcelain user has to install this external program explicitly might not be suitable when the program requires constant communication between beam process and external program On the plus side, unlike Exile, bugs in the implementation does not bring down whole beam VM. ExCmd This is my other stab at solving back pressure on the external program issue. It implements a demand-driven protocol using odu to solve this. Since ExCmd is also a port based solution, concerns previously mentioned applies to ExCmd too.","ref":"readme.html#rationale","title":"Exile - Rationale","type":"extras"},{"doc":"Internally Exile uses non-blocking asynchronous system calls to interact with the external process. It does not use port's message based communication instead does raw stdio using NIF. Uses asynchronous system calls for IO. Most of the system calls are non-blocking, so it should not block the beam schedulers. Makes use of dirty-schedulers for IO. Highlights Back pressure no middleware program no additional os process. No performance/resource cost no need to install any external command tries to handle zombie process by attempting to clean up external process. But as there is no middleware involved with exile, so it is still possible to endup with zombie process if program misbehave. stream abstraction selectively consume stdout and stderr streams If you are running executing huge number of external programs concurrently (more than few hundred) you might have to increase open file descriptors limit ( ulimit -n ) Non-blocking io can be used for other interesting things. Such as reading named pipe (FIFO) files. Exile.stream!(~w(cat data.pipe)) does not block schedulers, so you can open hundreds of fifo files unlike default file based io. TODO add benchmarks results 🚨 Obligatory NIF warning As with any NIF based solution, bugs or issues in Exile implementation can bring down the beam VM . But NIF implementation is comparatively small and mostly uses POSIX system calls. Also, spawned external processes are still completely isolated at OS level. If all you want is to run a command with no communication, then just sticking with System.cmd is a better. License Copyright (c) 2020 Akash Hiremath. Exile source code is released under Apache License 2.0. Check LICENSE for more information.","ref":"readme.html#exile","title":"Exile - Exile","type":"extras"},{"doc":"Apache License Version 2.0 , January 2004 http :// www . apache . org / licenses / TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License ; and (b) You must cause any modified files to carry prominent notices stating that You changed the files ; and (c) You must retain, in the Source form of any Derivative Works that You distribute , all copyright , patent , trademark , and attribution notices from the Source form of the Work , excluding those notices that do not pertain to any part of the Derivative Works ; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution , then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file , excluding those notices that do not pertain to any part of the Derivative Works , in at least one of the following places : within a NOTICE text file distributed as part of the Derivative Works ; within the Source form or documentation , if provided along with the Derivative Works ; or , within a display generated by the Derivative Works , if and wherever such third - party notices normally appear . The contents of the NOTICE file are for informational purposes only and do not modify the License . You may add Your own attribution notices within Derivative Works that You distribute , alongside or as an addendum to the NOTICE text from the Work , provided that such additional attribution notices cannot be construed as modifying the License . You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS","ref":"license.html","title":"LICENSE","type":"extras"}]